import React, { useState } from 'react';
import { Row, Col, Card, Button, Modal, Form } from 'react-bootstrap';
import BootstrapTable from 'react-bootstrap-table-next';
import _ from 'lodash';
import AnimatedTree from 'react-animated-tree';
import styled from 'styled-components';
import DualListBox from 'react-dual-listbox';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #008a60 !important;\n  font-size: 16px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #0077ac !important;\n  cursor: pointer;\n  font-size: 16px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  padding-left: 1rem;\n  margin-left: 2rem;\n  margin-bottom: 30px;\n  border-left: 3px solid #0077ac !important;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var TreeWrapper = styled.div(_templateObject());
var Icon = styled.i(_templateObject2());
var EnabledIcon = styled.i(_templateObject3());

var treeView = function treeView(props) {
  var treeStyles = {
    position: 'inherit',
    top: 40,
    left: 40,
    color: '#888',
    fill: '#000',
    width: '100%'
  };
  var typeProfile = /*#__PURE__*/React.createElement(Icon, {
    className: "feather icon-list align-middle"
  });
  var typeModule = /*#__PURE__*/React.createElement(Icon, {
    className: "feather icon-layers align-middle"
  });
  var typeEnabledAction = /*#__PURE__*/React.createElement(EnabledIcon, {
    className: "feather icon-check align-middle"
  });
  return /*#__PURE__*/React.createElement(TreeWrapper, null, /*#__PURE__*/React.createElement("h6", null, "Perfiles y permisos"), props.row.profileList.length > 0 ? props.row.profileList.map(function (profile) {
    return /*#__PURE__*/React.createElement(AnimatedTree, {
      key: profile.profileId,
      content: profile.name,
      type: typeProfile,
      open: true,
      style: treeStyles
    }, profile.moduleList.map(function (module) {
      return /*#__PURE__*/React.createElement(AnimatedTree, {
        key: module.moduleId,
        content: module.name,
        type: typeModule,
        open: true,
        style: treeStyles
      }, module.actionList.map(function (action) {
        return /*#__PURE__*/React.createElement(AnimatedTree, {
          key: action.actionId,
          type: typeEnabledAction,
          content: action.name
        });
      }));
    }));
  }) : /*#__PURE__*/React.createElement("h6", null, "No existen permisos asociados"));
};

function _templateObject2$1() {
  var data = _taggedTemplateLiteralLoose(["\nmargin-bottom: 10px;\ntext-align: right"]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$1() {
  var data = _taggedTemplateLiteralLoose(["\n  margin-right: 10px;\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var Icon$1 = styled.i(_templateObject$1());
var ActionBar = styled.div(_templateObject2$1());

var actionBar = function actionBar(props) {
  return /*#__PURE__*/React.createElement(ActionBar, null, /*#__PURE__*/React.createElement(Row, null, props.addView ? /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Card.Title, {
    as: "h5"
  }, "A\xF1adir Rol")) : /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Button, {
    onClick: props.handleView
  }, /*#__PURE__*/React.createElement(Icon$1, {
    className: "feather icon-plus"
  }), "A\xF1adir Rol"))));
};

function _templateObject$2() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #ffffff !important;\n  margin-right: 0 !important;\n"]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var Icon$2 = styled.i(_templateObject$2());

var actionColumn = function actionColumn(props) {
  var setId = function setId() {
    props.setCurrentId(props.roleId);
  };

  var triggerUpdate = function triggerUpdate() {
    props.openUpdateModal(props.roleId);
    setId();
  };

  var triggerDelete = function triggerDelete() {
    props.openDeleteModal();
    setId();
  };

  return /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    xs: 12,
    sm: 6,
    lg: 2
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: triggerUpdate
  }, /*#__PURE__*/React.createElement(Icon$2, {
    className: "feather icon-edit"
  }))), /*#__PURE__*/React.createElement(Col, {
    xs: 12,
    sm: 6,
    lg: 2
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: triggerDelete,
    className: "btn-danger"
  }, /*#__PURE__*/React.createElement(Icon$2, {
    className: "feather icon-trash-2"
  }))));
};

function _templateObject$3() {
  var data = _taggedTemplateLiteralLoose(["\n    color: #0077AC !important;\n    cursor: pointer;\n    font-size: 16px;\n"]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var Icon$3 = styled.i(_templateObject$3());

var expandIcon = function expandIcon(props) {
  var expanded = props.expanded;
  var iconClass = expanded ? 'icon-minus-square' : 'icon-plus-square';
  return /*#__PURE__*/React.createElement(Icon$3, {
    className: "feather " + iconClass
  });
};

function _templateObject$4() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #545454;\n  line-height:1;\n  margin-bottom: 0;\n"]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var Name = styled.p(_templateObject$4());

var nameColumn = function nameColumn(props) {
  var name = props.name;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Name, null, name));
};

function _templateObject$5() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #545454;\n  line-height:1;\n  margin-bottom: 0;\n"]);

  _templateObject$5 = function _templateObject() {
    return data;
  };

  return data;
}
var Description = styled.p(_templateObject$5());

var descriptionColumn = function descriptionColumn(props) {
  var description = props.description;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Description, null, description));
};

var ConfirmDeleteModal = function ConfirmDeleteModal(props) {
  var isDisabled = props.isDeleting || props.isDeleteSuccess;
  return /*#__PURE__*/React.createElement(Modal, {
    show: props.showModal,
    onHide: function onHide() {
      return props.toggleDeleteModal();
    },
    centered: true
  }, /*#__PURE__*/React.createElement(Modal.Header, {
    closeButton: true
  }, /*#__PURE__*/React.createElement(Modal.Title, {
    as: "h5"
  }, "Confirmaci\xF3n")), /*#__PURE__*/React.createElement(Modal.Body, null, /*#__PURE__*/React.createElement("h6", null, "Est\xE1 seguro que desea eliminar el Rol?")), /*#__PURE__*/React.createElement(Modal.Footer, null, /*#__PURE__*/React.createElement(Button, {
    disabled: isDisabled,
    variant: "secondary",
    onClick: function onClick() {
      return props.toggleDeleteModal();
    }
  }, "Cancelar"), /*#__PURE__*/React.createElement(Button, {
    disabled: isDisabled,
    onClick: function onClick() {
      return props.deleteRole(props.roleId);
    },
    variant: "primary"
  }, "Eliminar")));
};

function _templateObject$6() {
  var data = _taggedTemplateLiteralLoose(["\n  display: block;\n  width: 100%;\n  color: #e66c1f;\n  text-align: right;\n  margin-top: 5px;\n"]);

  _templateObject$6 = function _templateObject() {
    return data;
  };

  return data;
}
var Message = styled.div(_templateObject$6());

var AddRoleModal = function AddRoleModal(props) {
  var _useState = useState([]),
      selected = _useState[0],
      setSelected = _useState[1];

  var isDisabled = props.isAdding || props.isAddSuccess;
  var options = props.profiles.map(function (profile) {
    return {
      value: profile.profileId.toString(),
      label: profile.name
    };
  });

  var validateName = function validateName(value) {
    var error;

    if (!value) {
      error = 'Campo requerido';
    }

    return error;
  };

  return /*#__PURE__*/React.createElement(Modal, {
    show: props.showModal,
    onHide: function onHide() {
      return props.toggleAddModal();
    },
    centered: true
  }, /*#__PURE__*/React.createElement(Form, {
    onSubmit: function onSubmit(e) {
      e.preventDefault();
      handleSubmit();
    }
  }, /*#__PURE__*/React.createElement(Modal.Header, {
    closeButton: true
  }, /*#__PURE__*/React.createElement(Modal.Title, {
    as: "h5"
  }, "A\xF1adir Rol")), /*#__PURE__*/React.createElement(Modal.Body, null, /*#__PURE__*/React.createElement(Form.Group, null, /*#__PURE__*/React.createElement(Form.Label, null, "Nombre"), /*#__PURE__*/React.createElement(Form.Control, {
    id: "name",
    name: "name",
    type: "text",
    className: "form-control",
    validate: validateName,
    disabled: isDisabled
  })), /*#__PURE__*/React.createElement(Form.Group, null, /*#__PURE__*/React.createElement(Form.Label, null, "Descripci\xF3n"), /*#__PURE__*/React.createElement(Form.Control, {
    className: "form-control",
    component: "textarea",
    name: "description",
    rows: "6",
    disabled: isDisabled
  })), /*#__PURE__*/React.createElement(Form.Group, {
    controlId: "exampleForm.ControlTextarea1"
  }, /*#__PURE__*/React.createElement(Form.Label, null, "Perfiles"), /*#__PURE__*/React.createElement(DualListBox, {
    options: options,
    selected: selected,
    onChange: setSelected,
    disabled: isDisabled
  }))), /*#__PURE__*/React.createElement(Modal.Footer, null, /*#__PURE__*/React.createElement(Button, {
    variant: "secondary",
    onClick: function onClick() {
      return props.toggleAddModal();
    },
    disabled: isDisabled
  }, "Cancelar"), /*#__PURE__*/React.createElement(Button, {
    disabled: isDisabled,
    type: "submit",
    variant: "primary"
  }, "Guardar"))));
};

var UPdateRoleModal = function UPdateRoleModal(props) {
  var _props$roleData = props.roleData,
      profileList = _props$roleData.profileList;
  var isDisabled = props.isUpdating || props.isUpdateSuccess;
  var options = props.profiles.map(function (profile) {
    return {
      value: profile.profileId.toString(),
      label: profile.name
    };
  });
  var selectedArray = profileList.map(function (profileReq) {
    return props.profiles.filter(function (profile) {
      return profile.profileId === profileReq.profileId;
    });
  });
  var optionsSelected = selectedArray.map(function (profile) {
    return profile[0].profileId.toString();
  });

  var _useState = useState(optionsSelected),
      selected = _useState[0],
      setSelected = _useState[1];

  var validateName = function validateName(value) {
    var error;

    if (!value) {
      error = 'Campo requerido';
    }

    return error;
  };

  var onChange = function onChange(selected) {
    return setSelected(selected);
  };

  return /*#__PURE__*/React.createElement(Modal, {
    show: props.showModal,
    onHide: function onHide() {
      return props.toggleUpdateModal();
    },
    centered: true
  }, /*#__PURE__*/React.createElement(Form, {
    onSubmit: function onSubmit(e) {
      e.preventDefault();
      handleSubmit();
    }
  }, /*#__PURE__*/React.createElement(Modal.Header, {
    closeButton: true
  }, /*#__PURE__*/React.createElement(Modal.Title, {
    as: "h5"
  }, "Actualizar Rol")), /*#__PURE__*/React.createElement(Modal.Body, null, /*#__PURE__*/React.createElement(Form.Group, null, /*#__PURE__*/React.createElement(Form.Label, null, "Nombre"), /*#__PURE__*/React.createElement(Form.Control, {
    id: "name",
    name: "name",
    type: "text",
    className: "form-control",
    validate: validateName,
    disabled: isDisabled
  })), /*#__PURE__*/React.createElement(Form.Group, null, /*#__PURE__*/React.createElement(Form.Label, null, "Descripci\xF3n"), /*#__PURE__*/React.createElement(Form.Control, {
    className: "form-control",
    component: "textarea",
    name: "description",
    rows: "6",
    disabled: isDisabled
  })), /*#__PURE__*/React.createElement(Form.Group, {
    controlId: "exampleForm.ControlTextarea1"
  }, /*#__PURE__*/React.createElement(Form.Label, null, "Perfiles"), /*#__PURE__*/React.createElement(DualListBox, {
    options: options,
    selected: selected,
    onChange: onChange,
    disabled: isDisabled
  }))), /*#__PURE__*/React.createElement(Modal.Footer, null, /*#__PURE__*/React.createElement(Button, {
    variant: "secondary",
    onClick: function onClick() {
      return props.toggleUpdateModal();
    },
    disabled: isDisabled
  }, "Cancelar"), /*#__PURE__*/React.createElement(Button, {
    disabled: isDisabled,
    type: "submit",
    variant: "primary"
  }, "Guardar"))));
};

var columns = [{
  dataField: 'name',
  text: 'Rol',
  style: {
    whiteSpace: 'pre-line',
    verticalAlign: 'middle'
  }
}, {
  dataField: 'description',
  text: 'Descripción',
  style: {
    verticalAlign: 'middle',
    whiteSpace: 'pre-line'
  }
}, {
  dataField: 'actions',
  text: 'Acciones',
  style: {
    verticalAlign: 'middle'
  }
}];

var RoleManagement = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(RoleManagement, _React$Component);

  function RoleManagement() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      openDeleteRoleModal: false,
      openAddRoleModal: false,
      openUpdateRoleModal: false,
      showLoader: true,
      rolesData: null,
      roleData: null,
      roleId: null,
      currentRole: null,
      modalContent: null
    };

    _this.toggleModal = function (modalContent) {
      _this.setState(function (prevState) {
        return {
          showLoader: prevState.openDeleteRoleModal,
          openDeleteRoleModal: !prevState.openDeleteRoleModal
        };
      });

      _this.props.reset();
    };

    _this.toggleDeleteModal = function () {
      _this.setState(function (prevState) {
        return {
          showLoader: prevState.openDeleteRoleModal,
          openDeleteRoleModal: !prevState.openDeleteRoleModal
        };
      });

      _this.props.reset();
    };

    _this.toggleAddModal = function () {
      _this.setState(function (prevState) {
        return {
          showLoader: prevState.openAddRoleModal,
          openAddRoleModal: !prevState.openAddRoleModal
        };
      });

      _this.props.reset();
    };

    _this.toggleUpdateModal = function (roleId) {
      if (!_.isNil(roleId)) {
        _this.props.fetchRole(roleId);
      }

      _this.setState(function (prevState) {
        return {
          showLoader: prevState.openUpdateRoleModal,
          openUpdateRoleModal: !prevState.openUpdateRoleModal,
          roleData: null
        };
      });

      _this.props.reset();
    };

    _this.setCurrentId = function (roleId) {
      _this.setState({
        roleId: roleId
      });
    };

    _this.expandRow = {
      renderer: function renderer(row) {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(treeView, {
          row: row
        }));
      },
      showExpandColumn: true,
      expandByColumnOnly: true,
      expandHeaderColumnRenderer: function expandHeaderColumnRenderer(_ref) {
        return false;
      },
      expandColumnRenderer: function expandColumnRenderer(_ref2) {
        var expanded = _ref2.expanded;
        return /*#__PURE__*/React.createElement(expandIcon, {
          expanded: expanded
        });
      }
    };
    return _this;
  }

  var _proto = RoleManagement.prototype;

  _proto.componentDidMount = function componentDidMount() {};

  RoleManagement.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (!_.isEqual(nextProps.roles, prevState.rolesData)) {
      return {
        rolesData: nextProps.roles
      };
    }

    if (!_.isEqual(nextProps.role, prevState.roleData)) {
      return {
        roleData: nextProps.role
      };
    }

    return null;
  };

  _proto.render = function render() {
    var _this2 = this;

    var rolesData = this.state.rolesData.length > 0 ? this.state.rolesData.map(function (role) {
      return {
        id: role.rolId,
        profileList: role.profileList,
        name: /*#__PURE__*/React.createElement(nameColumn, {
          name: role.name
        }),
        description: /*#__PURE__*/React.createElement(descriptionColumn, {
          description: role.description
        }),
        actions: /*#__PURE__*/React.createElement(actionColumn, {
          roleId: role.rolId,
          setCurrentId: _this2.setCurrentId,
          openUpdateModal: _this2.toggleUpdateModal,
          openDeleteModal: _this2.toggleDeleteModal
        })
      };
    }) : [];
    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ConfirmDeleteModal, {
      roleId: this.state.roleId,
      toggleDeleteModal: this.toggleDeleteModal,
      showModal: this.state.openDeleteRoleModal,
      deleteRole: this.props.deleteRole,
      isDeleting: this.props.isDeleting,
      isDeleteSuccess: this.props.isDeleteSuccess,
      isDeleteError: this.props.isDeleteError
    }), /*#__PURE__*/React.createElement(AddRoleModal, {
      toggleAddModal: this.toggleAddModal,
      showModal: this.state.openAddRoleModal,
      profiles: this.props.profiles,
      addRole: this.props.addRole,
      isAdding: this.props.isAdding,
      isAddError: this.props.isAddError,
      isAddSuccess: this.props.isAddSuccess
    }), this.props.role && !_.isEmpty(this.props.role) ? /*#__PURE__*/React.createElement(UPdateRoleModal, {
      roleId: this.state.roleId,
      roleData: this.props.role,
      toggleUpdateModal: this.toggleUpdateModal,
      showModal: this.state.openUpdateRoleModal,
      profiles: this.props.profiles,
      updateRole: this.props.updateRole,
      isUpdating: this.props.isUpdating,
      isUpdateSuccess: this.props.isUpdateSuccess,
      isUpdateError: this.props.isUpdateError
    }) : null, /*#__PURE__*/React.createElement(actionBar, {
      handleView: this.toggleAddModal
    }), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement("div", {
      className: "role-container-main"
    }, /*#__PURE__*/React.createElement("div", {
      className: "role-container-header"
    }, /*#__PURE__*/React.createElement("h5", null, "Lista de roles")), /*#__PURE__*/React.createElement("div", {
      className: "task-data"
    }, /*#__PURE__*/React.createElement(BootstrapTable, {
      keyField: "id",
      data: rolesData,
      columns: columns,
      bordered: false,
      expandRow: this.expandRow
    }))))));
  };

  return RoleManagement;
}(React.Component);

export default RoleManagement;
//# sourceMappingURL=index.modern.js.map
